/*********************************************/
/*       File name:  setup_mserver6.c        */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define HOSTNAME_LENGTH 64

int mserver_socket(in_port_t port, int backlog)
	/* ߂l   ҂󂯃\Pbg̃fBXNv^ */
	/* port     ڑ̃|[gԍ               */
	/* backlog  ҂󂯂̐                     */
{
	/* ϐ̐錾 */
	struct addrinfo  hints; /* ɂĒmĂ镔Iȏ    */
	struct addrinfo *res;   /* hintsɊÂʂ̊i[ꏊw */
	int soc_waiting;        /* ڑ҂̃\Pbg                    */
	char portstring[8];     /* |[gԍ10i                */
	char hostname[HOSTNAME_LENGTH];               /* ̃zXg  */

	/* ̃qg̐ݒ */
	gethostname(hostname, HOSTNAME_LENGTH);
	sprintf(portstring, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* Ɋւ */
	if(getaddrinfo(hostname, portstring, &hints, &res) != 0){
		perror("getaddrinfo");
		return -1;
	}

	/* IPv4 ܂ IPv6 Ń\Pbg̍쐬 */
	if((soc_waiting = socket(res->ai_family,
	   res->ai_socktype, res->ai_protocol)) < 0){
		perror("socket");
		return -1;
	}

	/* \PbgɎ̃AhXݒ */
	if(bind(soc_waiting, res->ai_addr, res->ai_addrlen)!=0){
		perror("bind");
		return -1;
	}

	/* \PbgŐڑ҂̐ݒ */
	if (listen(soc_waiting, backlog) == -1){
		perror("listen");
		return -1;
	}
	fprintf(stderr,"successfully setup, now waiting.\n");

	/* ŎgI */
	freeaddrinfo(res);

	/* ҂󂯗p̃fBXNv^Ԃ */
	return soc_waiting;
}

/*  }`ANZvg  */

int mserver_maccept(int soc_waiting, int limit, void (*func)() )
	/* ߂l   ő̃\Pbg̃fBXNv^      */
	/* soc_waiting   ҂󂯂Ɏg\Pbg         */
	/* limit    accept ̏                       */
	/* func     accept Ɏs֐ւ̃|C^ */
{
	int i;   /* [vJE^ */
	int fd;  /* fBXNv^Ɨpϐ */

	/* accept  limit 񐔎s */
	for(i=0; i<limit; i++){
		if((fd = accept(soc_waiting, NULL, NULL))==-1){
			fprintf(stderr, "accept error\n");
			return -1;
		}
		(*func)(i, fd);
	}

	/* ҂󂯂̃\Pbg */
	close(soc_waiting);

	/* Ō fd ܂őlԂ */
	return fd;
}
