/*********************************************/
/*       File name:  session.c               */
/*    Project name:  socket/race             */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* [VOQ[̃ZbVW[ */

#include <curses.h>
#include <signal.h>
#include "race.h"

static char p[MAX_PLAYERS * PLAYER_SIZE]; /* ׂẴv[   */
static char temp[PLAYER_SIZE];            /* ̏(ꎞƗp) */
static char g[MAX_PLAYERS * GRADE_SIZE];  /* ׂẴv[̐ */

static int num;         /* QҐ       */
static int final;       /*  Xe[W    */
static int soc;         /*  \Pbg      */
static int entry_num;   /*  Ggԍ  */
static int flag;        /* ̏     */
static int final_state; /* ̍ŏI */

static char    *me;         /* ̏ւ̃|C^ */

static WINDOW  *win1, *win2; /* \pEBhE */

/*  level 2 ̊֐  */

static int  get_my_location();
static void send_my_data();
static void del_all_locations();
static void show_all_locations();
static void recv_all_data();
static int  new_stage(int z);

/*  level 3 ̊֐  */
static void init_data();
static int  check(int a, int b);
static void ending(int how);

/*  VOinh */
static void die();

/* ZbV̏  */

void session_init(int s)
	/* s  \Pbg */
{
	char buf[BUF_LENGTH];    /* ,Mobt@ */
	soc = s;                 /* \Pbg̃fBXNv^ */

	/* ڑ́uOCv */
	read(soc, buf, BUF_LENGTH);
	printf(buf);
	fgets(buf, BUF_LENGTH, stdin);  /* [薼O̓ */
	chop_newline(buf, BUF_LENGTH);

	write(soc, buf, strlen(buf)+1); /* ȎM */
	read(soc, buf, BUF_LENGTH);
	sscanf(buf, "%d", &entry_num );
	printf("Your entry number is %d\n", entry_num);
	read(soc, buf, BUF_LENGTH);     /* triger ҂ */
	sscanf(buf, "%d %d", &num, &final);
	printf("players are %d\n", num);
	printf("final stage is  %d\n", final);

	/* VOi̐ݒ */
	signal(SIGINT,die);
	signal(SIGQUIT,die);
	signal(SIGTERM,die);
	signal(SIGSEGV,die);
	signal(SIGPIPE,die);

	/* curses ̏ */
	initscr();
	noecho();
	crmode();
	nonl();

	/* EBhE̍쐬 */
	win1=newwin(22,12,1,10); /* R[X̕\p       */
	win2=newwin(11,25,5,40); /* [X̏󋵂̕\p */
	box(win1,'|','-');
	box(win2,'|','-');

	/* PXe[Wf[^̓ǂݍ */
	new_stage(1);

	/* f[^ */
	init_data();

	/* [X󋵂̏\ */
	mvwprintw(win2,2,1,"Entry Num=%d",entry_num);
	mvwprintw(win2,3,2,"num  stage  damage");
	mvwprintw(win2,entry_num+4,1,"*");

	/* R[X̕\ */
	show_all_locations();
}

/* ZbṼ[v */
void session_loop()
{
	flag = 1;

	while (flag){
		flag = get_my_location();  /* ̈ړ𓾂         */
		send_my_data();            /* ̃f[^𑗂         */
		del_all_locations();       /* ׂẴv[     */
		recv_all_data();           /* ׂẴf[^󂯎   */
		show_all_locations();      /* ̃Xe[Wɂ
		                              ׂẴv[\ */
	}
	ending(final_state);         /* I */
	die();
}


/*************/
/* level 2   */
/*************/

/* ̈ړ𓾂 */
static int get_my_location()
{
	int c;  /* ړL[󂯎 */

	c = getchar();

	switch(c){
	case	WEST:
		if (check(-1,0)==1)
		    temp[XPOS]--;
		 else
			temp[DAMAGE]++;
		break;
	case	SOUTH:
		if (check(0,1)==1)
		    temp[YPOS]++;
	else
			temp[DAMAGE]++;
	break;
	case	NORTH:
		if (temp[YPOS] == (char)1){
			temp[STAGE]++;          /* ̃Xe[W */
			temp[YPOS] = (char) 21; /* ̃Xe[W̃X^[gC */
			if (new_stage((int) temp[STAGE])==0){
				final_state = 0;
				return	0;
			}
		}
		else if (check(0,-1)==1)
			temp[YPOS]--;
			else
	    temp[DAMAGE]++;
	  break;
	case	EAST:
		if (check(1,0)==1)
		    temp[XPOS]++;
		else
		    temp[DAMAGE]++;
		break;
	default:
	  break;
	}

	if(temp[DAMAGE]>=MAX_DAMAGE){
		final_state = -1;
		return	0;
	}
	return	1;
}

/* ̃f[^̑M */
static void send_my_data()
{
	write(soc,&temp,PLAYER_SIZE);
}

/* ̃Xe[Wɂ邷ׂẴv[ */
static void del_all_locations()
{
	int	i;

	for (i=0; i<num; i++){
		if (p[i * PLAYER_SIZE + STAGE] == me[STAGE]){
			mvwaddch(win1, p[i * PLAYER_SIZE + YPOS],
			         p[i * PLAYER_SIZE + XPOS], ' ');
		}
	}
	touchwin(win1);
	wrefresh(win1);
}

/* ׂẴf[^T[o󂯂 */
static void recv_all_data()
{
	read(soc, p, PLAYER_SIZE * num);
}

/* ̃Xe[ŴׂẴv[\ */
static void show_all_locations()
{
	int	i;

	for(i=0; i<num; i++){
		if (p[i * PLAYER_SIZE + STAGE] == me[STAGE])
			mvwaddch(win1, p[i * PLAYER_SIZE + YPOS],
			         p[i * PLAYER_SIZE + XPOS], (char)(i+0x30) );
	}
	touchwin(win1);
	wrefresh(win1);

	mvwprintw(win2,9,2,"stage=%2d/%2d", (int)me[STAGE], final);
	for(i=0; i<num; i++)
		mvwprintw(win2,i+4,2," %2d  %2d     %2d ",
		          i, (int)p[i * PLAYER_SIZE + STAGE],
		             (int)p[i * PLAYER_SIZE + DAMAGE]);

	wrefresh(win2);
}

/* wXe[W̃R[Xf[^ǂݍ */
static int new_stage(int z)
	/* ߂l   0ȂI */
	/* z       Xe[Wԍ */
{
	FILE *fp;
	int   i;
	static char buf[16];

	if (z > final) return 0;

	sprintf(buf,"data/data%d",z);
	fp=fopen(buf,"r");
	for(i=1;i<=STAGE_LENGTH;i++){
		fgets(buf,16,fp);
		buf[10]='\0';
		wmove(win1,i,1);
		waddstr(win1,buf);
	}
	fclose(fp);
	return 1;
}

/* I */
static void ending(int how)
{
	int	i;

	wclear(win2);
	box(win2,'|','-');
	if (how == 0)
		mvwprintw(win2,1,3,"Goal in, Wait!");
	else
		mvwprintw(win2,1,3,"Crashed, Wait!");
	wrefresh(win2);

	read(soc,g,GRADE_SIZE * num);
	for(i=0;i<num;i++){
		mvwprintw(win2,i+3,1,"[%d] %d: %s",
		          i+1,
		          (int)g[i * GRADE_SIZE + ENTRYNUM],
		          &g[i * GRADE_SIZE + ENTRYNAME]);
	}
	wrefresh(win2);
	getchar();
}


/*************/
/* level 3   */
/*************/

/* f[^̏ */
static void init_data()
{
	int	i;

	me = p + PLAYER_SIZE * entry_num;
	for(i=0;i<num;i++){
		p[i * PLAYER_SIZE + STAGE] = (char)1;
		p[i * PLAYER_SIZE + XPOS] = (char)(2+i);
		p[i * PLAYER_SIZE + YPOS] = (char)20;
		p[i * PLAYER_SIZE + DAMAGE] = (char)0;
	}
	memcpy(temp, me, PLAYER_SIZE);
}

/* Qւ̏Փ˂R[XAEg̃`FbN */
static int check(int a, int b)
	/* ߂l   1͈S   0͈ړs */
	/* a,b ړ̕                 */
{
	int	p,q;

	p = temp[XPOS] + a;
	q = temp[YPOS] + b;

	if (p<1 || p>STAGE_WIDTH || q<1 || q>STAGE_LENGTH+1)
		return  0;

	/* mvwinch  chtype (maybe u_long)ԂB
	   񂾂oɂ
	   ̃rbgZKvB                 */

	if( (A_CHARTEXT & mvwinch(win1, q, p))=='*')
		return  0;
	return  1;
}

/*************/
/* emergency */
/*************/


/* VOiяI */
static void die()
{
	endwin();
	echo();
	exit(1);
}
